; CC2Net.de - Treiber fr Flash-Zugriffe
; (c) by Andr Helbig
; Release: 18.04.2004

$segmented
$model(medium)
$extend
$nomod166
$stdnames(reg164ci.def)
$NOLOCALS

	regdef	R1,R2,R3,R4,R5,R6,R7,R8,R9,R10,R11,R12,R13,R14,R15
;non-used Regs by IC-Subs: R3, R5, R8, R9, R10, R11, ((R14), R15)
;**************************************************************************************************************

; P1L.0 CC60IO 
; P1L.1 COUT60
; P1L.2 CC61IO
; P1L.3 COUT61
; P1L.4 CC62IO
; P1L.5 COUT62
; P1L.6 COUT63
; P1L.7 CTRAP 
; P1H.0 CC6POS0
; P1H.1 CC6POS1
; P1H.2 CC6POS2
; P1H.3 T7IN   
; P1H.4 CC24IO 
; P1H.5 CC25IO
; P1H.6 CC26IO
; P1H.7 CC27IO


; Definition der OS-Routinen
OSsegment	EQU	0
i2c_start	EQU	0872AH	
i2c_stop	EQU	08752H
i2c_ready	EQU	0877AH
i2c_write	EQU	08782H	; Returns Ackn in R4 Bit0 invers
i2c_read	EQU	0880EH	; Returns Data in R4, for readlast R12=1 else R12=0
POP_R4		EQU	0765AH	;uses: R4, R12, R13, R14
PUSH_R12	EQU	075D6H	;uses: R1, R2, R12, R13,R14,R15
POP_LONG	EQU	07680H  ;return in R4, R5
PUSH_LONG	EQU	075fEH  ;Value in R12, R13


userseg		SECTION CODE word at 3E000h
assume	dpp3:userseg


;************************************************************************************************************

DelSeg	proc far
	CALLS   0,0255ch	 ;Lschroutine in int. RAM kopieren
 	CALLS	0, POP_R4
	MOV	R12,R4
	CALLS   0,02552h	;Erase-routine
	POP	R1
	POP	R1
	RETS
DelSeg	endp

readInt	proc far
	CALLR	getAddr
	EXTS	R4,#1
	MOV	R12,[R2]
	CALLS   0,PUSH_R12
	POP	R1
	POP	R1
	RETS
readInt	endp

wrInt	proc far
	CALLS   0, 025d0h	;Schreibroutine in int. RAM kopieren
 	CALLS	0, POP_R4	;Data
	MOV	R6, R4
	CALLR	getAddr
	MOV	R12, R4
	MOV	R13, R2
	MOV	R14, R6
	CALLS   0,02552h	;Schreib-Routine
	MOV	R12, R4
	CALLS   0,PUSH_R12
	POP	R1
	POP	R1
	RETS
wrInt	endp

getAddr	proc near
 	CALLS	0, POP_R4	;Addr
	MOV	R2, R4
	AND	R2,#0FFFEh
 	CALLS	0, POP_R4	;Segment
	RETN
getAddr	endp

rdLong	proc far
	CALLR	getAddr
	EXTS	R4,#1
	MOV	R12,[R2+]
	EXTS	R4,#1
	MOV	R13,[R2]
	CALLS   0,PUSH_Long
	POP	R1
	POP	R1
	RETS
rdLong	endp

wrLong	proc far
	CALLS   0, 025d0h	;Schreibroutine in int. RAM kopieren
 	CALLS	0, POP_LONG	;Data
	MOV	R6, R4
	MOV	R7, R5
	CALLR	getAddr
	MOV	R12, R4
	MOV	R13, R2
	MOV	R14, R6
	CALLS   0,02552h	;Schreib-Routine
	MOV	R3, R4

	ADD	R13, #2
	MOV	R14, R7
	CALLS   0,02552h	;Schreib-Routine
	AND	R4, R3
	MOV	R12, R4
	CALLS   0,PUSH_R12
	POP	R1
	POP	R1
	RETS
wrLong	endp


;Arrays

rByteAr	proc far
 	CALLS	0, POP_R4	;Len
	MOV	R3, R4
 	CALLS	0, POP_R4	;Data
	MOV	R6, R4
 	CALLS	0, POP_R4	;Addr
	MOV	R2, R4
 	CALLS	0, POP_R4	;Segment
_1:
	CMPD1	R3,#0
	JMPR	cc_EQ,_1a
	EXTS	R4,#1
	MOVB	RL1,[R2+]
	EXTS	#8,#1
	MOVB	[R6],RL1
	ADD	R6,#1
	JMPR	cc_UC,_1
_1a:
	POP	R1
	POP	R1
	RETS
rByteAr	endp


wByteAr	proc far
	CALLR	setWrAr
	SHR	R3,#1
 	CALLS	0, POP_R4	;Data
	MOV	R6, R4
	CALLR	getAddr
	MOV	R12, R4
	MOV	R13, R2
	MOV	R2,#0FFFFh
_2:
	CMPD1	R3,#0
	JMPR	cc_EQ,_2a
	EXTS	#8,#1
	MOVB	RL1,[R6+]
	EXTS	#8,#1
	MOVB	RH1,[R6+]
	MOV	R14,R1
	CALLS   0,02552h	;Schreib-Routine
	AND	R2,R4
	ADD	R13,#2
	JMPR	cc_UC,_2
_2a:
	MOV	R12, R2
	CALLS   0,PUSH_R12
	POP	R1
	POP	R1
	RETS
wByteAr	endp


readArr proc near
 	CALLS	0, POP_R4	;Data
	MOV	R6, R4
	CALLR	getAddr
_5:
	CMPD1	R3,#0
	JMPR	cc_EQ,_5a
	EXTS	R4,#1
	MOV	R12,[R2+]
	EXTS	#8,#1
	MOV	[R6],R12
	ADD	R6,#2
	JMPR	cc_UC,_5
_5a:
        RETN
readArr endp

wrArray	proc near
 	CALLS	0, POP_R4	;Data
	MOV	R6, R4
	CALLR	getAddr
	MOV	R12, R4
	MOV	R13, R2
	MOV	R2,#0FFFFh
_6:
	CMPD1	R3,#0
	JMPR	cc_EQ,_6a
	EXTS	#8,#1
	MOV	R14,[R6+]
	CALLS   0,02552h	;Schreib-Routine
	AND	R2,R4
	ADD	R13,#2
	JMPR	cc_UC,_6
_6a:

	MOV	R12, R2
	CALLS   0,PUSH_R12
	RETN
wrArray	endp

getArrD	proc near

	RETN
getArrD	endp

rIntArr	proc far
 	CALLS	0, POP_R4	;Len
	MOV	R3, R4
	CALLR	readArr
	POP	R1
	POP	R1
	RETS
rIntArr	endp

wrIntAr	proc far
	CALLR	setWrAr
	CALLR	wrArray
	POP	R1
	POP	R1
	RETS
wrIntAr	endp

setWrAr	proc near
	CALLS   0, 025d0h	;Schreibroutine in int. RAM kopieren
 	CALLS	0, POP_R4	;Len
	MOV	R3, R4
	RETN
setWrAr endp

rLongAr	proc far
 	CALLS	0, POP_R4	;Len
	MOV	R3, R4
	SHL	R3,#1
	CALLR	readArr
	POP	R1
	POP	R1
	RETS
rLongAr	endp

wrLngAr	proc far
	CALLR	setWrAr
	SHL	R3,#1
	CALLR	wrArray
	POP	R1
	POP	R1
	RETS
wrLngAr	endp



userseg	ENDS
	END

